package com.example.demo.controller;

import com.example.demo.tool.Server;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.*;
import java.net.*;

@RestController
@RequestMapping("/")
public class NetController {

    @GetMapping("/net-base")
    public void baseDemo() throws UnknownHostException {
        InetAddress inetAddress = InetAddress.getLocalHost();
        System.out.print(inetAddress.getHostAddress());
        System.out.print("\r\n");
        System.out.print(inetAddress.getHostName());
    }

    @GetMapping("/socket")
    public void socketDemo(){
        Server server;
        int port = 1024;
        BufferedReader bufferedReader;
        PrintWriter printWriter;
        server = new Server(port);
        bufferedReader = new BufferedReader(new InputStreamReader(server.inputStream));
        printWriter = new PrintWriter(new OutputStreamWriter(server.outputStream));
    }

    @GetMapping("/udp-r")
    public void udpDemo() throws IOException {
        DatagramPacket datagramPacket;
        DatagramSocket datagramSocket;
        byte[] buffer = new byte[20];
        String msg;
        System.out.print("服务端开始接收数据");
        while (true){
            datagramPacket = new DatagramPacket(buffer, buffer.length);
            datagramSocket = new DatagramSocket(9995);
            datagramSocket.receive(datagramPacket);
            msg = new String(buffer,0,datagramPacket.getLength());
            System.out.print("信息为：" + msg + "\r\n");
            datagramSocket.close();
        }
    }

    @GetMapping("/udp-s")
    public void udpSendDemo() throws IOException {
        System.out.print("发送消息\r\n");
        String msg= "msg 123232";
        byte[]  buffer = msg.getBytes();
        DatagramPacket datagramPacket = new DatagramPacket(buffer,buffer.length, InetAddress.getByName("127.0.0.1"),9995);
        DatagramSocket datagramSocket = new DatagramSocket();
        datagramSocket.send(datagramPacket);
        datagramSocket.close();
    }

    @GetMapping("/url")
    public void urlDemo() throws MalformedURLException {
        URL url = new URL("https://blog.csdn.net/diandianxiyu_geek");
        System.out.print(url.getProtocol() + "\r\n");
        System.out.print(url.getPath() + "\r\n");
        System.out.print(url.getHost() + "\r\n");
        System.out.print(url.getFile() + "\r\n");
        System.out.print(url.getQuery() + "\r\n");
        System.out.print(url.getRef() + "\r\n");
    }
}
